function isz_features = rad_ISZ(image_nii,roi_nii,NUM_BIN_ISZ)
% Function : rad_ISZ
%            Calculate ISZM based features
% Input : image_nii,roi_nii,NUM_BIN_ISZ
% Output : 2 features
%          [size_zone_variability_ISZ, intensity_zone_variability_ISZ]


ISZM = rad_ISZ_build_ISZM_6(image_nii,roi_nii,NUM_BIN_ISZ);

% Size zone variability
size_zone_variability_ISZ = rad_ISZ_size_zone_variability(ISZM);

% Intensity zone variability
intensity_zone_variability_ISZ = rad_ISZ_intensity_zone_variability(ISZM);

isz_features = [size_zone_variability_ISZ, intensity_zone_variability_ISZ];

end