function [gray_level,zone_size,roi_visit_map] = rad_ISZ_DFS4ISZM_BUILD(roi_idx_input,roi_visit_map,image_binned,roi_nii)
%% DFS Fucntion for ISZ Build
%% Initial Settings
gray_level = image_binned(roi_idx_input);
[queue_DFS(1,1), queue_DFS(1,2), queue_DFS(1,3)] = ind2sub(size(roi_nii.img), roi_idx_input);
queue_head = 1;
queue_tail = 2;

%% Define 6 direction
neighbor_6 = ...
    [1,0,0; ...
    -1,0,0; ...
    0,1,0; ...
    0,-1,0; ...
    0,0,1; ...
    0,0,-1];

%% DFS to find same gray-level voxels
same_inten_clustermap = 1;
while queue_head ~= queue_tail
    head_i = queue_DFS(queue_head,1);
    head_j = queue_DFS(queue_head,2);
    head_k = queue_DFS(queue_head,3);
    
    ii = 1;
    while ii <= 6
        if roi_visit_map(head_i+neighbor_6(ii,1), head_j+neighbor_6(ii,2), head_k+neighbor_6(ii,3)) == 0 && ...
                roi_nii.img(head_i+neighbor_6(ii,1), head_j+neighbor_6(ii,2), head_k+neighbor_6(ii,3)) == 1 && ...
                image_binned(head_i+neighbor_6(ii,1), head_j+neighbor_6(ii,2), head_k+neighbor_6(ii,3)) == gray_level
            
            
            queue_DFS(queue_tail,:) = [head_i+neighbor_6(ii,1), head_j+neighbor_6(ii,2), head_k+neighbor_6(ii,3)];
            queue_tail = queue_tail + 1;

            roi_visit_map(head_i+neighbor_6(ii,1), head_j+neighbor_6(ii,2), head_k+neighbor_6(ii,3)) = 1;
            same_inten_clustermap = same_inten_clustermap + 1;
        end
        ii = ii + 1;
    end
    
    queue_head = queue_head + 1;
end

zone_size = same_inten_clustermap;
end