function ISZM = rad_ISZ_build_ISZM_6(image_nii,roi_nii,NUM_BIN_ISZ)
%% Build Intensity Size Zone Matrix using 6 direction DFS

MAX_ZONE_SIZE = 256;
ISZM = zeros(NUM_BIN_ISZ,MAX_ZONE_SIZE);
%% Binning
roi_idx = find(roi_nii.img);

image_binned = nan(size(image_nii.img));
image_binned(roi_idx) = image_nii.img(roi_idx) - min(image_nii.img(roi_idx));
rng = range(image_binned(:));
image_binned = floor(image_binned/(rng/NUM_BIN_ISZ));
image_binned(find(image_binned == max(image_binned(:)))) = NUM_BIN_ISZ - 1;
image_binned = image_binned + 1;

%% Calculate ISZ
roi_visit_map = zeros(size(roi_nii.img));


length_roi_idx = length(roi_idx);
roi_idx_idx = 1;
tic
while roi_idx_idx <= length_roi_idx
    if roi_visit_map(roi_idx(roi_idx_idx)) == 0
        roi_visit_map(roi_idx(roi_idx_idx)) = 1;
        [gray_level,zone_size,roi_visit_map] = rad_ISZ_DFS4ISZM_BUILD(roi_idx(roi_idx_idx),roi_visit_map,image_binned,roi_nii);

        if zone_size > MAX_ZONE_SIZE
            zone_size = MAX_ZONE_SIZE;
        end
        ISZM(gray_level,zone_size) = ISZM(gray_level,zone_size) + 1;
    end
    
    roi_idx_idx = roi_idx_idx + 1;
end
toc

end

